/* bsp11.q: Aufzeichnung einer MIDI-Sequenz */

import midi, mididev;

def (_,IN,_) = MIDIDEV!0, (_,OUT,PORT) = MIDIDEV!0, REF = midi_open "bsp11",
  _ = midi_connect IN REF || midi_connect REF OUT;

/* Herausfiltern unerwnschter Ereignisse */

def _ = midi_accept_type REF active_sense false ||
  midi_accept_type REF clock false;

/* Eingabeschleife */

recloop L (_,_,_,stop)	= reverse L;
recloop L (_,_,T,MSG)	= midi_send REF PORT MSG ||
			  recloop [(T,MSG)|L] (midi_get REF) otherwise;

/* Hauptfunktion */

public record;

record			= midi_flush REF || recloop [] (midi_get REF);
